<?php

namespace app\Controllers;

use vendor\Controller;
use app\Models\Ticket as TicketModel;
use app\Models\Seat as SeatModel;
use app\Middleware\AuthMiddleware;
use vendor\DB;

class Ticket extends Controller
{

    private $em;
    private $seat;
    public function __construct()
    {
        $this->em = new TicketModel();
        $this->seat = new SeatModel();
    }

    public function getTicket()
    {
        if (isset($_POST["id"])) {
            $id = $_POST["id"];
            return $this->em->getTicket($id);
        } else {
            return $this->em->getTickets();
        }
    }


    public function newTicket()
    {
        $Price = $_POST["Price"];
        $Trans_ID = $_POST["Trans_ID"];
        $Date = $_POST["Date"];
        $Order_Time = date("Y-m-d H:i:s");
        $Type = $_POST["Type"];
        $arrival = $_POST["arrival"];
        $dept = $_POST["dept"];
        $Owner = $_POST["Owner"];

        return $this->em->newTicket($Price, $Trans_ID, $Date, $Type, $arrival, $dept, $Order_Time,$Owner);
    }

    public function updateTicket()
    {
        $Price = $_POST["Price"];
        $Trans_ID = $_POST["Trans_ID"];
        $Date = $_POST["Date"];
        $Order_Time = date("Y-m-d H:i:s");
        $id = $_POST["id"];
        $Type = $_POST["Type"];
        return $this->em->updateTicket($Price, $Trans_ID, $Date, $Type, $Order_Time, $id);
    }

    public function removeTicket()
    {
        $id = $_POST["id"];
        return $this->em->removeTicket($id);
    }

    public function orderTickets()
    {
        $Price = $_POST["Price"];
        $Trans_ID = $_POST["Trans_ID"];
        $Date = $_POST["Date"];
        $Order_Time = date("Y-m-d H:i:s");
        $Type = $_POST["Type"];
        $arrival = $_POST["arrival"];
        $dept = $_POST["dept"];
        $Owner = AuthMiddleware::getUser()["result"][0]["id"];
        // var_dump($Owner);

        $left = $this->em->leftSeat($Date, $Trans_ID, $Type);
        // var_dump($left);
        if ($left > 0) {
            return $this->em->newTicket($Price, $Trans_ID, $Date, $Type, $arrival, $dept, $Order_Time,$Owner);
        } elseif ($left <= 0) {
            $response["status"] = 500;
            $response["message"] = "座位售完,或有其他問題";
            return $response;
        }

    }

    public function getMyTicket()
    {
        return $this->em->getMyTicket();
    }
    public function getMyTicketByID(){
        $id = $_POST["id"];
        return $this->em->getMyTicketByID($id);
    }
}
