<?php

namespace app\Models;

use vendor\DB;

class Route
{
    public function newRoute($StationCode, $DeptTime, $ArrivalTime, $Price)
    {
        $sql = "INSERT INTO `Route` ( `StationCode`, `DeptTime`, `ArrivalTime`,`Price`) VALUES (?, ?, ?, ?)";
        return DB::insert($sql, array($StationCode, $DeptTime, $ArrivalTime, $Price));
    }

    public function getRoutes()
    {

        $sql = "SELECT  *  FROM  `Route`";
        $arg = NULL;
        return DB::select($sql, $arg);
    }
    
    public function getRoute($id)
    {
        $sql = "SELECT  *  FROM  `Route` where `TransID`= ?";
        $arg = array($id);
        return DB::select($sql, $arg);
    }

    public function getRoutesMax()
    {

        $sql = "SELECT  max(id) as id FROM  `Route` ";
        $arg = NULL;
        return DB::select($sql, $arg);
    }

    public function getRouteByTrain($TrainID)
    {
        $sql = "SELECT Trans.TransID,Trans.RouteID,Station.StationName,Station.code,Route.arrivalTime,Route.deptTime,Route.Price FROM Trans INNER JOIN Route ON Trans.RouteID = Route.id INNER JOIN Station ON Route.StationCode = Station.code WHERE TransID = ? ORDER BY Route.Price";
        $arg = array($TrainID);
        return DB::select($sql, $arg);
    }

    public function updateRoute($StationCode, $DeptTime, $ArrivalTime, $Price, $id)
    {
        $sql = "UPDATE `Route` SET
        `StationCode` = ?,
        `DeptTime` = ?,
        `ArrivalTime` = ?,
        `Price` = ?
        WHERE `id` = ?;";
        return DB::update($sql, array($StationCode, $DeptTime, $ArrivalTime, $Price, $id));
    }

    public function removeRoute($id)
    {
        $sql = "DELETE FROM `Route` WHERE id=?";
        return DB::delete($sql, array($id));
    }
}
