<?php

namespace app\Models;

use app\Middleware\AuthMiddleware;
use vendor\DB;

class Ticket
{
    public function newTicket($Price, $Trans_ID, $Date, $Type, $arrival, $dept, $Order_Time, $Owner)
    {
        $sql = "INSERT INTO `Ticket` ( `Price`, `Trans_ID`, `Date`, `Type`, `arrival`, `dept`, `Order_Time`, `Owner`) VALUES (?, ?, ?, ?, ?, ?, ?, ?)";
        return DB::insert($sql, array($Price, $Trans_ID, $Date, $Type, $arrival, $dept, $Order_Time, $Owner));
    }

    public function getTickets()
    {

        $sql = "SELECT  *  FROM  `Ticket`";
        $arg = NULL;
        return DB::select($sql, $arg);
    }

    public function getTicket($id)
    {
        $sql = "SELECT  *  FROM  `Ticket` where `id` = ?";
        $arg = array($id);
        return DB::select($sql, $arg);
    }

    public function updateTicket($Price, $Trans_ID, $Date, $Type, $Order_Date, $id)
    {
        $sql = "UPDATE `Ticket` SET
        `Price` = ?
        `Trans_ID` = ?,
        `Date` = ?,
        `Type` = ?,
        `Order_Time` = ?
        WHERE `id` = ?;";
        return DB::update($sql, array($Price, $Trans_ID, $Date, $Type, $Order_Date, $id));
    }

    public function removeTicket($id)
    {
        $sql = "DELETE FROM `Ticket` WHERE id=?";
        return DB::delete($sql, array($id));
    }

    public function getMyTicket()
    {
        $Owner = AuthMiddleware::getUser()["result"][0]["id"];
        $sql = "SELECT * FROM `Ticket` WHERE `Owner` = ?";
        return DB::select($sql, array($Owner));
    }
    public function getMyTicketByID($id)
    {
        $Owner = AuthMiddleware::getUser()["result"][0]["id"];
        $sql = "SELECT Ticket.*,Arrival.ArrivalTime,Dept.DeptTime,Arrival.StationName as ArrivalStation ,Dept.StationName as DeptStation,Ticket.Price as Price
                FROM
                    (SELECT Trans.TransID,Route.ArrivalTime, Station.StationName FROM Trans INNER JOIN Route ON Trans.RouteID = Route.id INNER JOIN Station ON Route.StationCode = Station.code WHERE Route.StationCode = (SELECT arrival FROM Ticket where id = ?) AND Trans.TransID = (SELECT Trans_ID FROM Ticket where id = ?)) as Arrival,
                    (SELECT Trans.TransID,Route.DeptTime,  Station.StationName FROM Trans INNER JOIN Route ON Trans.RouteID = Route.id INNER JOIN Station ON Route.StationCode = Station.code WHERE Route.StationCode = (SELECT dept FROM Ticket where id = ?) AND Trans.TransID = (SELECT Trans_ID FROM Ticket where id = ?)) as Dept,
                    (SELECT * FROM Ticket WHERE id = ?) Ticket
                WHERE Arrival.TransID = Dept.TransID";
        return DB::select($sql, array($id,$id,$id,$id,$id));
    }

    public function leftSeat($date, $TransID, $Type)
    {
        // print($date.$TransID.$Type);
        // $sql = 'SELECT (Quantity - (SELECT count(*) as Sold from Ticket where date = ? AND Trans_ID = ? AND Type = ?)) as left FROM  `Seat` where `TransID` = ? and `Type` = ?';
        $sql = 'SELECT (Quantity - (SELECT count(*) as Sold from Ticket WHERE `Date` = ? AND `Type` = ? AND `TransID` = ?)) as g FROM  `Seat` where `TransID` = ? and `Type` = ?';
        return DB::select($sql, array($date, $Type, $TransID, $TransID, $Type))["result"][0]["g"];
    }
}
