<?php

namespace app\Models;

use vendor\DB;

class Trains
{
    public function newTrain($route_id, $trans_id)
    {
        $sql = "INSERT INTO `Trans` ( `TransID`, `RouteID`) VALUES (?, ?)";
        return DB::insert($sql, array($route_id, $trans_id));
    }

    public function getTrains()
    {

        $sql = "SELECT DISTINCT TransID FROM  `Trans`";
        $arg = NULL;
        return DB::select($sql, $arg);
    }


    public function getTrain($id)
    {
        $sql = "SELECT Trans.TransID,Station.StationName,Station.code FROM Trans INNER JOIN Route ON Trans.RouteID = Route.id INNER JOIN Station ON Route.StationCode = Station.code WHERE TransID = ? ORDER BY Route.Price";
        $arg = array($id);
        return DB::select($sql, $arg);
    }

    public function updateTrain($route_id, $trans_id, $id)
    {
        $sql = "UPDATE `Trans` SET `TransID`=?,`RouteID`=? where id = ?";
        return DB::update($sql, array($route_id, $trans_id, $id));
    }

    public function removeTrain($id)
    {
        $sql = "DELETE FROM `Trans` WHERE TransID=?";
        return DB::delete($sql, array($id));
    }

    public function getTrainsTime($arrival,$dept,$dept_Time)
    {
        $sql = "SELECT Arrival_Station_Routes.TransID AS Train, 
        concat(Departure_Station_Routes.DeptTime,'-', Arrival_Station_Routes.ArrivalTime, '    ', Hour(TIMEDIFF(Arrival_Station_Routes.ArrivalTime, Departure_Station_Routes.DeptTime)),  'hr', ' ', Minute(TIMEDIFF(Arrival_Station_Routes.ArrivalTime, Departure_Station_Routes.DeptTime)), 'min') AS Time,
        concat(Arrival_Station_Routes.Price-Departure_Station_Routes.Price) as Price
        FROM 
            (SELECT Trans.TransID, Route.ArrivalTime, Route.DeptTime, Route.Price
            FROM Route INNER JOIN Trans ON Route.id = Trans.RouteID
            AND Route.StationCode = ?) Arrival_Station_Routes,
                (SELECT Trans.TransID, Route.ArrivalTime, Route.DeptTime, Route.Price
                FROM Route INNER JOIN Trans
                ON Route.id = Trans.RouteID AND Route.StationCode = ?) Departure_Station_Routes 
                WHERE Arrival_Station_Routes.TransID = Departure_Station_Routes.TransID AND Departure_Station_Routes.DeptTime >= ?;";
        $arg = array($arrival,$dept,$dept_Time);
        return DB::select($sql, $arg);
    }
}
