<?php
namespace vendor;
use vendor\Controller;
use \PDO;
use \PDOException;


class DB extends Controller
{
    // private static $db_host = 'adminer.p.treexhd.me';
    // private static $db_name = 'MVCFrame_1004';
    // private static $db_user = 'MVCFrame';
    // private static $db_password = 'SeWq9maKbQSDCzqz';
    // private static $conn = NULL;
    // private static $response = '';
    public static $dbHost;
    public static $dbName;
    public static $dbUser;
    public static $dbPassword;
    private static $conn = NULL;


    static function connect()
    {
        if (self::$conn != NULL) return;
        $dsn = sprintf("mysql:host=%s;dbname=%s;charset=utf8", self::$dbHost, self::$dbName);
        try {
            self::$conn = new PDO($dsn, self::$dbUser, self::$dbPassword);
        } catch (PDOException $e) {
            self::$conn = NULL;
        }
    }

    static function select($sql, $args)
    {
        DB::connect();
        if (self::$conn == NULL) return self::response(14, "無法開啟DB");
        $stmt = self::$conn->prepare($sql);
        $result = $stmt->execute($args);
        if ($result) {
            $rows = $stmt->fetchAll(PDO::FETCH_ASSOC);
            return self::response(200, "查詢成功", $rows);
        } else {
            return self::response(400, "SQL錯誤");
        }
    }

    static function insert($sql, $args)
    {
        DB::connect();
        //執行新增動作
        if (self::$conn == NULL) return self::response(14, "無法開啟DB");
        $stmt = self::$conn->prepare($sql);
        $result = $stmt->execute($args);
        if ($result) {
            $count = $stmt->rowCount();
            return ($count < 1) ? self::response(504, "新增失敗") : self::response(200, "新增成功");
        } else {
            return self::response(400, "SQL錯誤");
        }
    }
    static function delete($sql, $args)
    {
        DB::connect();
        //執行刪除動作
        if (self::$conn == NULL) return self::response(14, "無法開啟DB");
        $stmt = self::$conn->prepare($sql);
        $result = $stmt->execute($args);
        if ($result) {
            $count = $stmt->rowCount();
            return ($count < 1) ? self::response(504, "刪除失敗") : self::response(200, "刪除成功");
        } else {
            return self::response(400, "SQL錯誤");
        }
    }
    static function update($sql, $args)
    {
        DB::connect();
        //執行更新動作
        if (self::$conn == NULL) return self::response(14, "無法開啟DB");
        $stmt = self::$conn->prepare($sql);
        $result = $stmt->execute($args);
        if ($result) {
            $count = $stmt->rowCount();
            return ($count < 1) ? self::response(504, "更新失敗") : self::response(200, "更新成功");
        } else {
            return self::response(400, "SQL錯誤");
        }
    }

}
